//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: ibc/applications/transfer/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service.
///
/// Usage: instantiate `Ibc_Applications_Transfer_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Ibc_Applications_Transfer_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Ibc_Applications_Transfer_V1_QueryClientInterceptorFactoryProtocol? { get }

  func denomTrace(
    _ request: Ibc_Applications_Transfer_V1_QueryDenomTraceRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryDenomTraceRequest, Ibc_Applications_Transfer_V1_QueryDenomTraceResponse>

  func denomTraces(
    _ request: Ibc_Applications_Transfer_V1_QueryDenomTracesRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryDenomTracesRequest, Ibc_Applications_Transfer_V1_QueryDenomTracesResponse>

  func params(
    _ request: Ibc_Applications_Transfer_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryParamsRequest, Ibc_Applications_Transfer_V1_QueryParamsResponse>
}

extension Ibc_Applications_Transfer_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "ibc.applications.transfer.v1.Query"
  }

  /// DenomTrace queries a denomination trace information.
  ///
  /// - Parameters:
  ///   - request: Request to send to DenomTrace.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denomTrace(
    _ request: Ibc_Applications_Transfer_V1_QueryDenomTraceRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryDenomTraceRequest, Ibc_Applications_Transfer_V1_QueryDenomTraceResponse> {
    return self.makeUnaryCall(
      path: "/ibc.applications.transfer.v1.Query/DenomTrace",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomTraceInterceptors() ?? []
    )
  }

  /// DenomTraces queries all denomination traces.
  ///
  /// - Parameters:
  ///   - request: Request to send to DenomTraces.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denomTraces(
    _ request: Ibc_Applications_Transfer_V1_QueryDenomTracesRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryDenomTracesRequest, Ibc_Applications_Transfer_V1_QueryDenomTracesResponse> {
    return self.makeUnaryCall(
      path: "/ibc.applications.transfer.v1.Query/DenomTraces",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomTracesInterceptors() ?? []
    )
  }

  /// Params queries all parameters of the ibc-transfer module.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Ibc_Applications_Transfer_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Applications_Transfer_V1_QueryParamsRequest, Ibc_Applications_Transfer_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/ibc.applications.transfer.v1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }
}

internal protocol Ibc_Applications_Transfer_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'denomTrace'.
  func makeDenomTraceInterceptors() -> [ClientInterceptor<Ibc_Applications_Transfer_V1_QueryDenomTraceRequest, Ibc_Applications_Transfer_V1_QueryDenomTraceResponse>]

  /// - Returns: Interceptors to use when invoking 'denomTraces'.
  func makeDenomTracesInterceptors() -> [ClientInterceptor<Ibc_Applications_Transfer_V1_QueryDenomTracesRequest, Ibc_Applications_Transfer_V1_QueryDenomTracesResponse>]

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Ibc_Applications_Transfer_V1_QueryParamsRequest, Ibc_Applications_Transfer_V1_QueryParamsResponse>]
}

internal final class Ibc_Applications_Transfer_V1_QueryClient: Ibc_Applications_Transfer_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Ibc_Applications_Transfer_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the ibc.applications.transfer.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Ibc_Applications_Transfer_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Ibc_Applications_Transfer_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Ibc_Applications_Transfer_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// DenomTrace queries a denomination trace information.
  func denomTrace(request: Ibc_Applications_Transfer_V1_QueryDenomTraceRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Applications_Transfer_V1_QueryDenomTraceResponse>

  /// DenomTraces queries all denomination traces.
  func denomTraces(request: Ibc_Applications_Transfer_V1_QueryDenomTracesRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Applications_Transfer_V1_QueryDenomTracesResponse>

  /// Params queries all parameters of the ibc-transfer module.
  func params(request: Ibc_Applications_Transfer_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Applications_Transfer_V1_QueryParamsResponse>
}

extension Ibc_Applications_Transfer_V1_QueryProvider {
  internal var serviceName: Substring { return "ibc.applications.transfer.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "DenomTrace":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Applications_Transfer_V1_QueryDenomTraceRequest>(),
        responseSerializer: ProtobufSerializer<Ibc_Applications_Transfer_V1_QueryDenomTraceResponse>(),
        interceptors: self.interceptors?.makeDenomTraceInterceptors() ?? [],
        userFunction: self.denomTrace(request:context:)
      )

    case "DenomTraces":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Applications_Transfer_V1_QueryDenomTracesRequest>(),
        responseSerializer: ProtobufSerializer<Ibc_Applications_Transfer_V1_QueryDenomTracesResponse>(),
        interceptors: self.interceptors?.makeDenomTracesInterceptors() ?? [],
        userFunction: self.denomTraces(request:context:)
      )

    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Applications_Transfer_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Ibc_Applications_Transfer_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Ibc_Applications_Transfer_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'denomTrace'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomTraceInterceptors() -> [ServerInterceptor<Ibc_Applications_Transfer_V1_QueryDenomTraceRequest, Ibc_Applications_Transfer_V1_QueryDenomTraceResponse>]

  /// - Returns: Interceptors to use when handling 'denomTraces'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomTracesInterceptors() -> [ServerInterceptor<Ibc_Applications_Transfer_V1_QueryDenomTracesRequest, Ibc_Applications_Transfer_V1_QueryDenomTracesResponse>]

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Ibc_Applications_Transfer_V1_QueryParamsRequest, Ibc_Applications_Transfer_V1_QueryParamsResponse>]
}
